commit 79d32baea4a94dd1d4e267a0e172fb15c238fb37
Author: Yang Yujie <yangyujie@loongson.cn>
Date:   Tue Jul 23 10:04:26 2024 +0800

    LoongArch: Remove gawk extension from a generator script.
    
    gcc/ChangeLog:
    
            * config/loongarch/genopts/gen-evolution.awk: Do not use
            "length()" to compute the size of an array.
    
    (cherry picked from commit c48f38288fb17b70784ae5e71cb741e664da023a)

diff --git a/gcc/config/loongarch/genopts/gen-evolution.awk b/gcc/config/loongarch/genopts/gen-evolution.awk
index 4d105afa906..1c8004e4146 100644
--- a/gcc/config/loongarch/genopts/gen-evolution.awk
+++ b/gcc/config/loongarch/genopts/gen-evolution.awk
@@ -1,4 +1,4 @@
-#!/usr/bin/gawk
+#!/usr/bin/awk -f
 #
 # A simple script that generates loongarch-evolution.h
 # from genopts/isa-evolution.in
@@ -94,8 +94,9 @@ function gen_cpucfg_useful_idx()
         idx_bucket[cpucfg_word[i]] = 1
 
     delete idx_list
+    j = 1
     for (i in idx_bucket)
-        idx_list[length(idx_list)-1] = i+0
+        idx_list[j++] = i+0
     delete idx_bucket
 
     asort (idx_list)
@@ -108,7 +109,7 @@ function gen_cpucfg_useful_idx()
     print ""
 
     printf ("static constexpr int N_CPUCFG_WORDS = %d;\n",
-            idx_list[length(idx_list)] + 1)
+            idx_list[j - 1] + 1)
 
     delete idx_list
 }

